require("dotenv").config();
const app = require("express")();
const { execSync } = require("child_process");

const PORT = process.env.PORT || 8356;
const AUTH_TOKEN =
  process.env.AUTH_TOKEN ||
  execSync("tr -dc A-Za-z0-9 </dev/urandom | head -c 100");

app.use("/", (req, res, next) => {
  console.log(`${req.method} ${req.path} ${req.ip}`);
  next();
});

app.get("/deploy", (req, res) => {
  console.log(req.query);
  if (req.query.auth_token === AUTH_TOKEN) {
    try {
      const stdout = execSync(`bash -lc '"${__dirname}/deploy.bash"'`);
      console.log(stdout.toString());
      res.sendStatus(200);
    } catch (err) {
      console.log(err.stderr.toString());
      res.sendStatus(500);
    }
  } else {
    res.sendStatus(401);
  }
});

app.listen(PORT, () => {
  console.log(`Deployment API listening on port ${PORT}`);
});
